<?php
/*

   Copyright 2010 e-WebFace Networks

   Plugin Name: e-WebFace
Plugin URI: http://www.e-webface.com
Version: 1.0
Autor: e-WebFace Networks
Autor URL: http://e-WebFace.com/
Descrição: A e-Webface é um sistema de videoconferência pela web. Este plugin integra a e-Webface com o WordPress permitindo blogueiros criarem e gerenciarem salas de reuniões para interagir com seus leitores para mais informações sobre como configurar o servidor de e-Webface entre em http://www.e-webface.com

Versão 1.0 escrito por Renato Souza Gengo
*/

defined('_JEXEC') or die('Restricted access'); 

require_once( JPATH_COMPONENT.DS.'includes'.DS.'ewf_api.php');
$msg = null;
if(!$this->salt || $this->salt == '' || !$this->url || $this->url == '' ){
	$msg = "You have to fill out the salt and url in the settings menu before you can begin.";
}
else if( count($this->items) > 0){
	$printed = false;
    $k = 0;
	
    for ($i=0, $n=count( $this->items ); $i < $n; $i++)
    {
        $row =& $this->items[$i];
        $checked    = JHTML::_( 'grid.id', $i, $row->id );
		$joinLink = JRoute::_( 'index.php?option=com_ewebfaceconferencing&controller=meeting&task=join&id='. $row->id );
		$endLink = JRoute::_( 'index.php?option=com_ewebfaceconferencing&controller=meeting&task=end&id='. $row->id );
		$deleteLink = JRoute::_( 'index.php?option=com_ewebfaceconferencing&controller=meeting&task=delete&id='. $row->id );

		$response = ewebface::getMeetingInfoArray( $row->meetingName.'['.$row->meetingVersion.']', $row->moderatorPW, $this->url, $this->salt );
		
		if(!$response){//If the server is unreachable, then prompts the user of the necessary action
			$msg = "Unable to display the meetings. Please check the url of the ewebface server AND check to see if the ewebface server is running.";
			break;
		}
		else if( isset($response['returncode']) && $response['returncode'] == 'FAILED' && $response['messageKey'] != 'notFound' &&  $response['messageKey'] != 'invalidPassword') { //The meeting was not created
			if($response['messageKey'] == 'checksumError'){
				$msg = "A checksum error occured. Make sure you entered the correct salt.";
			}
			else{
				$msg = $response['message'];
			}
			break;
		}
		else {
			if( ( isset($response['returncode']) && $response['returncode'] == 'FAILED' && $response['messageKey'] == 'notFound') 
				|| (isset($response['returncode']) && $response['returncode'] == 'FAILED' && $response['messageKey'] == 'invalidPassword')
				|| ($response['running'] == 'false') ) $running = false;
			else $running = true;
			
		if(!$printed){
			$printed = true;
			?>
			<form action="index.php" method="post" name="adminForm">
			<div id="editcell">
				<table class="adminlist">
				<thead>
					<tr>
						<th width="20">
						  <input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
						</th>
						<th>
							<?php echo JText::_( 'Nome da Sala' ); ?>
						</th>
						<th>
							<?php echo JText::_( 'Aguardar por Palestrante' ); ?>
						</th>
						<th>
							<?php echo JText::_( 'Senha do Palestrante' ); ?>
						</th>
						<th>
							<?php echo JText::_( 'Senha do Participante' ); ?>
						</th>
						<th>
							<?php echo JText::_( 'Já iniciou?' ); ?>
						</th>
						<th>
							<?php echo JText::_( 'Ações' ); ?>
						</th>
					</tr>            
				</thead>
			<?php
		}
		
        ?>
        <tr class="<?php echo "row$k"; ?>">
            <td align="center" >
              <?php echo $checked; ?>
            </td>
            <td align="center">
                <?php echo $row->meetingName; ?>
            </td>
			<td align="center">
                <?php 
				if($row->waitForModerator == 'yes') echo "Sim";
				else echo "Não"; 
				?>
            </td>
			<td align="center">
                <?php echo $row->moderatorPW; ?>
            </td>
			<td align="center">
                <?php echo $row->attendeePW; ?>
            </td>
			<td align="center">
                <?php 
				if($running) echo "Sim"; 
				else echo "Não"; 
				?>
            </td>
			<td align="center">
                <a href="<?php echo $joinLink; ?>"><?php echo JText::_( 'Entrar' ); ?></a>
				<?php if($running){ ?> <a href="<?php echo $endLink; ?>"><?php echo JText::_( 'End' ); ?></a><?php } ?>
				<a href="<?php echo $deleteLink; ?>"><?php echo JText::_( 'Apagar' ); ?></a>
            </td>
        </tr>
        <?php
        $k = 1 - $k;
		}
    }
	
	if(!$msg){
		?>
			</table>
		</div>
		<?php
	}
}
else{
	$msg = "Ainda não foi criada nenhuma Sala.";
}

if($msg){
?> 
<form action="index.php" method="post" name="adminForm">
	<dl id="system-message">
		<dt class="message">Message</dt>
		<dd class="message message fade">
			<ul>
				<li><?php echo $msg; ?></li>
			</ul>

		</dd>
	</dl>
<?php
}
?>
	<input type="hidden" name="option" value="com_ewebfaceconferencing" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="controller" value="meeting" />
</form>