<?php
/*

   Copyright 2010 e-WebFace Networks

   Plugin Name: e-WebFace
Plugin URI: http://www.e-webface.com
Version: 1.0
Autor: e-WebFace Networks
Autor URL: http://e-WebFace.com/
Descrição: A e-Webface é um sistema de videoconferência pela web. Este plugin integra a e-Webface com o WordPress permitindo blogueiros criarem e gerenciarem salas de reuniões para interagir com seus leitores para mais informações sobre como configurar o servidor de e-Webface entre em http://www.e-webface.com

Versão 1.0
*/

require_once( dirname(__FILE__).DS.'php'.DS.'ewf_api.php' );

class modewebfaceHelper{

    function getForm($params){
        //Makes sure there isn't duplicate meetings.
		$db = JFactory::getDBO();
		$query = "SELECT * FROM #__ewf";
		$db->setQuery($query);
		$list = $db->loadObjectList();
		return $list;
    }
	
    function join( $params ){
	
		$meetingName = JRequest::getVar( 'meetingName' );
		$name = JRequest::getVar( 'display_name' );
		$pwd = JRequest::getVar( 'pwd' );
		
		$query = "SELECT * FROM #__ewf WHERE meetingName ='".$meetingName."'";
		$db =& JFactory::getDBO();
		$db->setQuery( $query );
		$meeting = $db->loadObject();
			
		if(!$meeting || $meeting == null){
			$msg['message'] = "This meeting no longer exists.";
			return $msg;
		}
		
		if($meeting->moderatorPW != $pwd && $meeting->attendeePW != $pwd){
			$msg['message'] = "Incorrect Password.";
			return $msg;
		}
		
		
		// This is the security salt that must match the value set in the ewebface server
		// This is the URL for the ewebface server
		
		$query = "SELECT * FROM #__ewf_settings WHERE name = 'salt'";
		$db->setQuery( $query );
		$salt = $db->loadObject();
		
		$query = "SELECT * FROM #__ewf_settings WHERE name = 'url'";
		$db->setQuery( $query );
		$url = $db->loadObject();

		if(!$salt || $salt->varValue == '' || !$url || $url->varValue == ''){
			$msg['message'] = "You have to fill out the salt and url in the settings menu before you can join a meeting.";
			return $msg;
		}
		
		
		for(;;){

			$response = ewebface::createMeetingArray($name, $meeting->meetingName."[".$meeting->meetingVersion."]", 'Welcome to '.$meeting->meetingName.'.', $meeting->moderatorPW, $meeting->attendeePW, $salt->varValue, $url->varValue, JURI::base() );		
			//Analyzes the bigbluebutton server's response
			if(!$response){//If the server is unreachable, then prompts the user of the necessary action
				$msg['message'] = "Unable to join the meeting. Please check the url of the bigbluebutton server AND check to see if the bigbluebutton server is running.";
				return $msg;
			}
			else if( $response['returncode'] == 'FAILED' && $response['messageKey'] != 'idNotUnique') { //The meeting was not created
				if($response['messageKey'] == 'checksumError'){
					$msg['message'] = "A checksum error occured. Make sure you entered the correct salt.";
				}
				else{
					$msg['message'] = $response['message'];
				}
				return $msg;
			}
			else if( $response['messageKey'] == 'idNotUnique' || $response['hasBeenForciblyEnded'] == 'true'){
				$meeting->meetingVersion = time();
				
				$db->updateObject('#__ewf',$meeting,'id',false);
				if ($db->getErrorNum()) {  
					$msg['message'] = $db->getErrorMsg();  
					return $msg;
				}			
			}
			else{ //The meeting was created, and the user will now be joined
				$ewf_joinURL = ewebface::joinURL($meeting->meetingName."[".$meeting->meetingVersion."]", $name,$pwd, $salt->varValue, $url->varValue );
				
				
				if($meeting->waitForModerator == 'yes' && $meeting->moderatorPW != $pwd && !ewebface::isMeetingRunning( $meeting->meetingName."[".$meeting->meetingVersion."]", $url->varValue, $salt->varValue )){
									
					$msg['message'] = "redirect";
					$msg['ewf_joinURL'] = $ewf_joinURL;
					$msg['name'] = $name;
					//$msg['meetingID'] = urlencode($meeting->meetingName."[".$meeting->meetingVersion."]");
					$msg['meetingID'] = ewebface::isMeetingRunningURL( $meeting->meetingName."[".$meeting->meetingVersion."]",$url->varValue, $salt->varValue );
					
					return $msg;
				
				}
				
				?><script type="text/javascript"> window.location = "<?php echo $ewf_joinURL ?>";</script><?php
				return;
			}
		}
    }
}
?>
